var xSelector = function (selector) {
    return {
        selector: selector,
        locateStrategy: 'xpath'
    }
};

var fileManagerCommand= {
    open: function() {
        this.api.pause(1000);

        return this.waitForElementVisible('@fileManagerBtn', 1000)
            .click('@fileManagerBtn')
            .waitForElementVisible('@fileManagerDialog', 1000);
    },
    close: function() {
        this.api.pause(1000);

        return this.click('@fileManagerClose')
            .waitForElementNotVisible('@fileManagerDialog', 1000);
    },
    openDirBrowser: function () {
        this.api.pause(1000);

        return this.waitForElementVisible('@dirBrowserBtn', 1000)
            .click('@dirBrowserBtn')
            .waitForElementVisible('@fileTreeDialog', 1000);
    },
    selectDir: function () {
        this.api.pause(1000);

        return this.waitForElementVisible('@dirSelectBtn', 1000)
            .click('@dirSelectBtn')
            .waitForElementNotVisible('@fileTreeDialog', 1000);
    },
    cancelDirBrowser: function () {
        this.api.pause(1000);

        return this.waitForElementVisible('@dirBrowserCancelBtn', 1000)
            .click('@dirBrowserCancelBtn')
            .waitForElementNotVisible('@fileTreeDialog', 1000);
    },
    closeDirBrowser: function () {
        this.api.pause(1000);

        return this.waitForElementVisible('@dirBrowserCloseBtn', 1000)
            .click('@dirBrowserCloseBtn')
            .waitForElementNotVisible('@fileTreeDialog', 1000);
    },
    clickHome: function () {
        this.api.pause(1000);

        return this.waitForElementVisible('@homeBtn', 1000)
            .click('@homeBtn');
    },
    clickReload: function () {
        this.api.pause(1000);

        return this.waitForElementVisible('@reloadBtn', 1000)
            .click('@reloadBtn');
    },
    clickSave: function () {
        this.api.pause(1000);

        return this.waitForElementVisible('@saveBtn', 1000)
            .click('@saveBtn')
            .waitForElementVisible('@saveDialog', 1000);
    },
    clickClear: function () {
        this.api.pause(1000);

        return this.waitForElementVisible('@clearBtn', 1000)
            .click('@clearBtn');
    },
    linkNodes: function(fromSelector, toSelector, xpos, ypos) {
        return this.api
                .useXpath()
                .moveToElement(fromSelector, 3, 0)
                .mouseButtonDown('left')
                .moveToElement(fromSelector, xpos, ypos) //drag somewhere near the Node terminal
                .moveToElement(toSelector,  3, 0)
                .mouseButtonUp('left');
    },
};

module.exports = {
    commands: [fileManagerCommand],
    elements: {
        fileManagerBtn: xSelector('//*[@id="fileManagerButton"]'),
        fileManagerDialog: xSelector('//*[@id="fileManagerDialog"]'),
        fileManagerClose: xSelector('//div[@aria-describedby="fileManagerDialog"]/div/button[@title="close"]'),
        dataPath: xSelector('//*[@id="datapath"]'),
        filter: xSelector('//*[@id="fileManagerDialog"]/form/input'),
        fileList: xSelector('//*[@id="grid"]/table/tbody'),
        console: xSelector('//*[@id="console"]'),
        consoleStatus: xSelector('//*[@id="console"]/tbody/tr[1]/td[2]'),
        fileName: xSelector('//*[@id="console"]/tbody/tr[2]/td[2]'),
        homeBtn: xSelector('//*[@id="homeDir"]'),
        reloadBtn: xSelector('//*[@id="fileUploadContainer"]/span[2]'),
        dloadBtn: xSelector('//*[@id="grid"]/table/tbody/tr/td[3]/a'),
        delBtn: xSelector('//*[@id="grid"]/table/tbody/tr/td[3]/button[1]'),
        openNfileBtn: xSelector('//*[@id="grid"]/table/tbody/tr[1]/td[3]/button[2]'),
        clearBtn: xSelector('//*[@id="clear"]'),
        canvasDiv: xSelector('//*[@id="canvas2_MAIN"]'),

        /**
         * Directory Browser
         */
        dirBrowserBtn: xSelector('//*[@id="openDir"]'),
        dirBrowserCloseBtn: xSelector('//div[@aria-describedby="fileTreeDialog"]/div/button[@title="close"]'),
        dirBrowserCancelBtn: xSelector('//div[@aria-describedby="fileTreeDialog"]/div/div/button/span[text()="Cancel"]'),
        dirSelectBtn: xSelector('//div[@aria-describedby="fileTreeDialog"]/div/div/button/span[text()="Select"]'),
        testDir: xSelector('//*[@id="Test_anchor"]'),
        testDirSub: xSelector('//*[@id="A_anchor"]'),
        fileTreeDialog: xSelector('//*[@id="fileTreeDialog"]'),
        fileTree: xSelector('//*[@id="fileTree"]'),

        /**
         * Pagination
         */
        pages: xSelector('//*[@id="paginator"]/div'),
        firstPage: xSelector('//*[@id="paginator"]/div/ul/li[1]'),
        prevPage: xSelector('//*[@id="paginator"]/div/ul/li[2]'),
        pageOne: xSelector('//*[@id="paginator"]/div/ul/li[3]'),

        firstPageAnchor: xSelector('//*[@id="paginator"]/div/ul/li[1]/a'),
        prevPageAnchor: xSelector('//*[@id="paginator"]/div/ul/li[2]/a'),
        pageOneAnchor: xSelector('//*[@id="paginator"]/div/ul/li[3]/a'),

        nextPage: xSelector('//*[@id="paginator"]/div/ul/li[4]'),
        lastPage: xSelector('//*[@id="paginator"]/div/ul/li[5]'),

        pageTwo2: xSelector('//*[@id="paginator"]/div/ul/li[4]'),
        nextPage2: xSelector('//*[@id="paginator"]/div/ul/li[5]'),
        lastPage2: xSelector('//*[@id="paginator"]/div/ul/li[6]'),
        pageTwo2anchor: xSelector('//*[@id="paginator"]/div/ul/li[4]/a'),
        nextPage2anchor: xSelector('//*[@id="paginator"]/div/ul/li[5]/a'),
        lastPage2anchor: xSelector('//*[@id="paginator"]/div/ul/li[6]/a'),

        pageTwo3: xSelector('//*[@id="paginator"]/div/ul/li[4]'),
        pageThree3: xSelector('//*[@id="paginator"]/div/ul/li[5]'),
        nextPage3: xSelector('//*[@id="paginator"]/div/ul/li[6]'),
        lastPage3: xSelector('//*[@id="paginator"]/div/ul/li[7]'),

        pageFour4: xSelector('//*[@id="paginator"]/div/ul/li[4]'),
        nextPage4anchor: xSelector('//*[@id="paginator"]/div/ul/li[13]/a'),
        lastPage4anchor: xSelector('//*[@id="paginator"]/div/ul/li[14]/a'),

        /**
         * Upload
         */
        uploadBtn: xSelector('//*[@id="fileUploadFile"]'),
        fixtureDelete_1: xSelector('//div/div/div/div/table/tbody/tr/td[text()="sample.n"]/following-sibling::td/button[contains(@title, "Delete")]'),
        fixtureLoad_1: xSelector('//div/div/div/div/table/tbody/tr/td[text()="sample.n"]/following-sibling::td/button[contains(@title, "Load")]'),
        fixtureDownload_1: xSelector('//div/div/div/div/table/tbody/tr/td[text()="sample.n"]/following-sibling::td/a[contains(@title, "Download")]'),
        fixtureType_1: xSelector('//div/div/div/div/table/tbody/tr/td[text()="sample.n"]/following-sibling::td[contains(text(), "network")]'),
        fixture_1: xSelector('//div/div/div/div/table/tbody/tr/td[text()="sample.n"]'),

        fixtureDelete_2: xSelector('//div/div/div/div/table/tbody/tr/td[text()="sample.wav"]/following-sibling::td/button[contains(@title, "Delete")]'),
        fixtureDownload_2: xSelector('//div/div/div/div/table/tbody/tr/td[text()="sample.wav"]/following-sibling::td/a[contains(@title, "Download")]'),
        fixtureType_2: xSelector('//div/div/div/div/table/tbody/tr/td[text()="sample.wav"]/following-sibling::td[contains(text(), "audio")]'),
        fixture_2: xSelector('//div/div/div/div/table/tbody/tr/td[text()="sample.wav"]'),

        fixtureDelete_3: xSelector('//div/div/div/div/table/tbody/tr/td[text()="sampleraw.raw"]/following-sibling::td/button[contains(@title, "Delete")]'),
        fixtureDownload_3: xSelector('//div/div/div/div/table/tbody/tr/td[text()="sampleraw.raw"]/following-sibling::td/a[contains(@title, "Download")]'),
        fixtureType_3: xSelector('//div/div/div/div/table/tbody/tr/td[text()="sampleraw.raw"]/following-sibling::td[contains(text(), "audio")]'),
        fixture_3: xSelector('//div/div/div/div/table/tbody/tr/td[text()="sampleraw.raw"]'),

        fixtureDelete_4: xSelector('//div/div/div/div/table/tbody/tr/td[text()="datfile.dat"]/following-sibling::td/button[contains(@title, "Delete")]'),
        fixtureDownload_4: xSelector('//div/div/div/div/table/tbody/tr/td[text()="datfile.dat"]/following-sibling::td/a[contains(@title, "Download")]'),
        fixtureType_4: xSelector('//div/div/div/div/table/tbody/tr/td[text()="datfile.dat"]/following-sibling::td[contains(text(), "tf")]'),
        fixture_4: xSelector('//div/div/div/div/table/tbody/tr/td[text()="datfile.dat"]'),

        fixtureDelete_5: xSelector('//div/div/div/div/table/tbody/tr/td[text()="sampletff.tff"]/following-sibling::td/button[contains(@title, "Delete")]'),
        fixtureDownload_5: xSelector('//div/div/div/div/table/tbody/tr/td[text()="sampletff.tff"]/following-sibling::td/a[contains(@title, "Download")]'),
        fixtureType_5: xSelector('//div/div/div/div/table/tbody/tr/td[text()="sampletff.tff"]/following-sibling::td[contains(text(), "tf")]'),
        fixture_5: xSelector('//div/div/div/div/table/tbody/tr/td[text()="sampletff.tff"]'),

        fixtureDelete_6: xSelector('//div/div/div/div/table/tbody/tr/td[text()="tf.zip"]/following-sibling::td/button[contains(@title, "Delete")]'),
        fixtureDownload_6: xSelector('//div/div/div/div/table/tbody/tr/td[text()="tf.zip"]/following-sibling::td/a[contains(@title, "Download")]'),
        fixtureType_6: xSelector('//div/div/div/div/table/tbody/tr/td[text()="tf.zip"]/following-sibling::td[contains(text(), "tf")]'),
        fixture_6: xSelector('//div/div/div/div/table/tbody/tr/td[text()="tf.zip"]'),

        fixtureDelete_7: xSelector('//div/div/div/div/table/tbody/tr/td[text()="invalidtf.zip"]/following-sibling::td/button[contains(@title, "Delete")]'),
        fixtureDownload_7: xSelector('//div/div/div/div/table/tbody/tr/td[text()="invalidtf.zip"]/following-sibling::td/a[contains(@title, "Download")]'),
        fixtureType_7: xSelector('//div/div/div/div/table/tbody/tr/td[text()="invalidtf.zip"]/following-sibling::td[contains(text(), "others")]'),
        fixture_7: xSelector('//div/div/div/div/table/tbody/tr/td[text()="invalidtf.zip"]'),

        fixtureDelete_8: xSelector('//div/div/div/div/table/tbody/tr/td[text()="otherfile.xml"]/following-sibling::td/button[contains(@title, "Delete")]'),
        fixtureDownload_8: xSelector('//div/div/div/div/table/tbody/tr/td[text()="otherfile.xml"]/following-sibling::td/a[contains(@title, "Download")]'),
        fixtureType_8: xSelector('//div/div/div/div/table/tbody/tr/td[text()="otherfile.xml"]/following-sibling::td[contains(text(), "others")]'),
        fixture_8: xSelector('//div/div/div/div/table/tbody/tr/td[text()="otherfile.xml"]'),

        /**
         * Save
         */
        saveBtn: xSelector('//*[@id="save"]'),
        saveDialog: xSelector('//*[@id="saveFileDialog"]'),
        saveInput: xSelector('//*[@id="networkName"]'),
        saveOK: xSelector('//div[@aria-describedby="saveFileDialog"]/div/div/button/span[text()="OK"]'),
        CATEio: xSelector('//*[@id="nodelist"]/li[@key="IO"]'),
        CATEharkAudioIO: xSelector('//*[@id="nodelist"]/li[@key="HARK:AudioIO"]'),
        NODEinputStream: xSelector('//*[@id="nodelist"]/li[@key="IO"]/ul/li[@key="InputStream"]'),
        NODEsaveWavePCM: xSelector('//*[@id="nodelist"]/li[@key="HARK:AudioIO"]/ul/li[@key="SaveWavePCM"]'),
        INsaveWavePCM: xSelector('//*[@id="node_SaveWavePCM_1_delim_INPUT"]/div'),
        OUTinputStream: xSelector('//*[@id="node_InputStream_1_delim_OUTPUT"]/div'),

        searchInput: xSelector('//*[@id="fileManagerDialog"]/form/input')

    }
};